//COPYRIGHT(C) 1998 BY JASON WINNEBECK.  YOU MAY FREELY DISTRIBUTE THIS
//SOURCE AND ACCOMPANYING FILES AS LONG AS YOU STILL KEEP THEM ALL TOGETHER,
//YOU DO NOT MODIFY THEM, AND YOU DON'T CLAIM THEM AS YOUR OWN WORK.

#include "jetfight.h"

//            *******EXPLOSIONS

int Explosions::Init() {
  tot = 0; curr = 0;

  for (char c=0; c < EXPLODE_MAX; c++)
    expls[c].active = 0;

  expl = load_datafile("expl.dat");

  if (expl == NULL)
    return 1;
  else
    return 0;
}

void Explosions::MakeNew(short x, short y) {
  expls[curr].active = 1;
  expls[curr].x = x;
  expls[curr].y = y;
  expls[curr].frame = 0;

  curr++;
  if (curr >= EXPLODE_MAX)
    curr = 0;
}

void Explosions::Update() {
  for (char c=0; c < EXPLODE_MAX; c++)
    if (expls[c].active) {
      Video.DrawDoodad((RLE_SPRITE *)expl[expls[c].frame].dat, expls[c].x, expls[c].y, 1);
      expls[c].frame++;

      if (expls[c].frame >= EXPLODE_FRAMES)
        expls[c].active = 0;
    }
}

//        ******SPRITES SYSTEM

int SpritesSystem::Init() {
  return Exp.Init();
}

void SpritesSystem::MakeNew(char type, short x, short y) {
  switch(type) {
    case 1:
      Exp.MakeNew(x, y);
      break;
    default:
      Exp.MakeNew(x, y);
      break;
  }
}

void SpritesSystem::Update() {
  Exp.Update();
}
