//COPYRIGHT(C) 1998 BY JASON WINNEBECK.  YOU MAY FREELY DISTRIBUTE THIS
//SOURCE AND ACCOMPANYING FILES AS LONG AS YOU STILL KEEP THEM ALL TOGETHER,
//YOU DO NOT MODIFY THEM, AND YOU DON'T CLAIM THEM AS YOUR OWN WORK.

//Made by:
//Jason Winnebeck
//Todd Wolfe
//Stephen "G" Iglesias
//Jason Asato

#include <stdio.h>
#include <conio.h>

#include <jrnd.h>
#include "jetfight.h"
#include <jpeg.h>

//Declare used drivers
DECLARE_GFX_DRIVER_LIST(
 GFX_DRIVER_VBEAF
 GFX_DRIVER_VESA3
 GFX_DRIVER_VESA2L
 GFX_DRIVER_VESA2B
)
DECLARE_COLOR_DEPTH_LIST(
 COLOR_DEPTH_8
 COLOR_DEPTH_32
 COLOR_DEPTH_24
)
DECLARE_DIGI_DRIVER_LIST(
 DIGI_DRIVER_SB
 DIGI_DRIVER_AUDIODRIVE
)
DECLARE_MIDI_DRIVER_LIST(
 MIDI_DRIVER_AWE32
 MIDI_DRIVER_MPU
 MIDI_DRIVER_ADLIB
 MIDI_DRIVER_SB_OUT
)
DECLARE_JOYSTICK_DRIVER_LIST(
 JOYSTICK_DRIVER_STANDARD
 JOYSTICK_DRIVER_SIDEWINDER
 JOYSTICK_DRIVER_GAMEPAD_PRO
)

int Loader();
void CopyrightNotice();

int main(int argc, char *argv[]) {
  if (Loader())
    return 1;

  Menus();

  unload_datafile(data);
  allegro_exit();

  CopyrightNotice();
}

void CopyrightNotice() { //Displays copyright notice on blank screen
  clrscr();
  printf("Jetfight v.%s\n", verno);
  printf(" Compiled with: DJGPP v2.02, the GNU C++ DOS compiler\n");
  printf(" And: %s\n", allegro_id);
  printf(" And: %s by %s", JPEG_DESC, JPEG_AUTHOR);
  printf(" And: BGUI v1.0\n");
  printf("COPYRIGHT(C) 1998 JASON WINNEBECK.  YOU MAY DISTRIBUTE THIS PROGRAM\n");
  printf(" FREELY, BUT YOU MAY NOT SPLIT UP OR MODIFY THE FILES, OR CLAIM THEM\n");
  printf(" AS YOUR OWN.\n");
}

int Loader() {
  CopyrightNotice();
  allegro_init();
  check_cpu();
  printf("Processor type: ");
  switch (cpu_family) {
    case 3:
      printf("386"); break;
    case 4:
      printf("486"); break;
    case 5:
      printf("586"); break;
    case 6:
      printf("686/PPro"); break;
    default:
      printf("Unknown"); break;
  }
  if (cpu_mmx)
    printf(" with mmx");
  printf("\n");

  randomize();
  printf("Installing timer. . .\n");
  install_timer();

  printf("Loading data files. . .\n");
  set_config_file("jetfight.cfg");
  set_color_depth(8);
  if ((data = load_datafile("jetfight.dat")) == NULL) {
    printf("**Error loading datafile ""jetfight.dat"", probably not found!\n");
    readkey();
    return 1;
  }
  printf("Installing SoundSystem. . .\n");
  if (Sound.Init())
    return 1;

  printf("Installing VideoSystem. . .\n");
  if (Video.Init()) {
    printf("**Error loading datafile ""expl.dat"", probably not found!\n");
    readkey();
    return 1;
  }

  printf("Installing WorldSystem. . .\n");
  if (World.Init())
    return 1;

  printf("Installing ControlSystem. . .\n");
  if (Control.Init())
    return 1;

  printf("**COMPLETE!!\n");

  if ((readkey() >> 8) == KEY_ESC)
    return 1;

  printf("Entering Graphics mode. . .\n");

  return 0;
}
