char *midilist_getter(int index, int *list_size) {
  static char *strings[] = {
    "None",  "Attack1", "Attack2", "Combat1", "Combat2"
  };

  if (index < 0) {
    *list_size = 5;
    return NULL;
  } else
    return strings[index];
}

char *tilelist_getter(int index, int *list_size) {
  static char *strings[] = {
    "Solid Water",  "Shoreline", "Solid Beach", "Beach to Grass",
    "Solid Grass",  "Grass to Jungle", "Solid Jungle",
    "Base Walls"
  };

  if (index < 0) {
    *list_size = 8;
    return NULL;
  } else
    return strings[index];
}

char *playerlist_getter(int index, int *list_size) {
  static char *strings[] = {
    "A10",  "F15"
  };

  if (index < 0) {
    *list_size = 2;
    return NULL;
  } else
    return strings[index];
}

char *enemylist_getter(int index, int *list_size) {
  static char *strings[] = {
    "A10", "F15"
  };

  if (index < 0) {
    *list_size = 2;
    return NULL;
  } else
    return strings[index];
}

char *actionlist_getter(int index, int *list_size) {
  static char *strings[] = {
    "no action", "goto x,y", "go away from x,y",
    "goto player", "go away from player", "attack player",
    "patrol", "defend area", "defend target"
  };

  if (index < 0) {
    *list_size = 9;
    return NULL;
  } else
    return strings[index];
}

char *waypointlist_getter(int index, int *list_size) {
  static char *strings[] = {
    "Waypoint 0", "Waypoint 1",
    "Waypoint 2", "Waypoint 3",
    "Waypoint 4", "Waypoint 5",
    "Waypoint 6", "Waypoint 7",
    "Waypoint 8", "Waypoint 9",
  };

  if (index < 0) {
    *list_size = 10;
    return NULL;
  } else
    return strings[index];
}

//Menuing Vars
MENU FileMenu[] = {
 //(title)                  (proc)      (Menu)      (Flags)      (void *)
  {"&New\tN",             NewMap,        NULL},
  {"",                      NULL,        NULL},
  {"&Load\tL",              Load,        NULL},
  {"&Save\tS",              Save,        NULL},
  {"",                      NULL,        NULL},
  {"E&xit\tQ",              Quit,        NULL},
  {NULL,                    NULL,        NULL}
};

MENU EditMenu[] = {
 //(title)                  (proc)      (Menu)      (Flags)      (void *)
  {"Copy\tCtrl-C",          NULL,        NULL, D_DISABLED},
  {"Paste\tCtrl-V",         NULL,        NULL, D_DISABLED},
  {NULL,                    NULL,        NULL,       NULL}
};

MENU MapMenu[] = {
 //(title)                  (proc)      (Menu)      (Flags)      (void *)
  {"Edit &Map Prop\tM",EditMapProp,      NULL},
  {"",                      NULL,        NULL},
  {"Edit Player",     EditPlayer,        NULL},
  {"",                      NULL,        NULL},
  {"&Start Music",    StartMusic,        NULL},
  {"&Stop Music",      StopMusic,        NULL},
  {NULL,                    NULL,        NULL}
};

MENU GotoMenu[] = {
 //(title)                  (proc)      (Menu)      (Flags)      (void *)
  {"&Player",         GotoPlayer,        NULL},
  {"",                      NULL,        NULL},
  {"&Air Enemy",            NULL,        NULL, D_DISABLED},
  {"&Ground Enemy",         NULL,        NULL, D_DISABLED},
  {"",                      NULL,        NULL},
  {"&Location",     GotoLocation,        NULL},
  {NULL,                    NULL,        NULL}
};

MENU MainMenu[] = {
 //(title)                  (proc)      (Menu)      (Flags)      (void *)
  {"&File",                 NULL,    FileMenu},
  {"&Edit",                 NULL,    EditMenu},
  {"&Map",                  NULL,     MapMenu},
  {"&Goto",                 NULL,    GotoMenu},
  {"&Help",             ShowHelp,        NULL},
  {"&Return (ESC)",     ExitMenu,        NULL},
  {NULL,                    NULL,        NULL}
};

//  ***RIGHT CLICK MENUS***
MENU AddEnemy[] = {
 //(title)                  (proc)      (Menu)      (Flags)      (void *)
  {"Air",            AddAirEnemy,        NULL},
  {"Ground",      AddGroundEnemy,        NULL,    D_DISABLED},
  {NULL,                    NULL,        NULL}
};

MENU DeleteEnemy[] = {
 //(title)                  (proc)      (Menu)      (Flags)      (void *)
  {"Air",         DeleteAirEnemy,        NULL},
  {"Ground",   DeleteGroundEnemy,        NULL},
  {NULL,                    NULL,        NULL}
};

MENU EditEnemy[] = {
 //(title)                  (proc)      (Menu)      (Flags)      (void *)
  {"Air",           EditAirEnemy,        NULL},
  {"Ground",                NULL,        NULL,    D_DISABLED},
  {NULL,                    NULL,        NULL}
};

MENU CopyEnemy[] = {
 //(title)                  (proc)      (Menu)      (Flags)      (void *)
  {"Air",                   NULL,        NULL,    D_DISABLED},
  {"Ground",                NULL,        NULL,    D_DISABLED},
  {NULL,                    NULL,        NULL}
};

MENU PasteEnemy[] = {
 //(title)                  (proc)      (Menu)      (Flags)      (void *)
  {"Air",                   NULL,        NULL,    D_DISABLED},
  {"Ground",                NULL,        NULL,    D_DISABLED},
  {NULL,                    NULL,        NULL}
};

MENU RightClickMenu[] = {
 //(title)                  (proc)      (Menu)      (Flags)      (void *)
  {"Add Enemy",             NULL,    AddEnemy},
  {"Delete Enemy",          NULL, DeleteEnemy},
  {"Edit Enemy",            NULL,   EditEnemy},
  {"Copy Enemy",            NULL,   CopyEnemy},
  {"Paste Enemy",           NULL,  PasteEnemy},
  {"",                      NULL,        NULL},
  {"Move Player",     MovePlayer,        NULL},
  {"",                      NULL,        NULL},
  {"Add Waypoint",   AddWaypoint,        NULL},
  {NULL,                    NULL,        NULL}
};

DIALOG main_menu_dialog[] = {
  /* (dialog proc)       (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
  {d_billmenu_proc,       0,    0, 1024,   16,     0,  0,    0,        0,    0,    0,  MainMenu},
  {NULL,                  0,    0,    0,    0,     0,  0,    0,        0,    0,    0,  NULL}
};

DIALOG mapprop[] = {
  /* (dialog proc)       (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
  {d_billwin_proc,        0,    0,  320,   80,     0,  0,    0,        0,    0,    0,  "Map Properties"},

  {d_ex_billbutton_proc,306,    4,   10,   10,     0,  0,    0,        0,    0,    0,  "x", SetRet, NULL},

  {d_billctext_proc,    160,   24,    0,   12,     0,  0,    0,        0,    0,    0,  "Select Midi", NULL},
  {d_billddlist_proc,    80,   32,  160,   14,     0,  0,    0,        0,    0,    0,  midilist_getter},

  {d_ex_billbutton_proc, 40,   52,   80,   16,     0,  0,  'o',        0,    0,    1,  "&OK", SetRet},
  {d_ex_billbutton_proc,200,   52,   80,   16,     0,  0,   27,        0,    0,    0,  "Cancel", SetRet},

  {d_check_exit,          0,    0,    0,    0,     0,  0,    0,        0,    0,    0,  NULL},
  {NULL,                  0,    0,    0,    0,     0,  0,    0,        0,    0,    0,  NULL}
};

#define midilist 3

DIALOG addairenemy[] = {
  /* (dialog proc)       (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
  {d_billwin_proc,        0,    0,  320,  192,     0,  0,    0,        0,    0,    0,  title},

  {d_ex_billbutton_proc,306,    4,   10,   10,     0,  0,    0,        0,    0,    0,  "x", SetRet, NULL},
  {d_billctext_proc,    160,   24,    0,   12,     0,  0,    0,        0,    0,    0,  "Select Enemy Type", NULL},
  {d_billddlist_proc,    80,   32,  160,   14,     0,  0,    0,        0,    0,    0,  enemylist_getter},

  {d_billctext_proc,     80,   56,    0,   12,     0,  0,    0,        0,    0,    0,  "Bullets"},
  {d_billctext_proc,    160,   56,    0,   12,     0,  0,    0,        0,    0,    0,  "Bombs"},
  {d_billctext_proc,    240,   56,    0,   12,     0,  0,    0,        0,    0,    0,  "Missiles"},
  {d_billedit_proc,      40,   72,   80,   14,     0,  0,    0,        0,    5,    0,  buffs[0]},
  {d_billedit_proc,     120,   72,   80,   14,     0,  0,    0,        0,    2,    0,  buffs[1]},
  {d_billedit_proc,     200,   72,   80,   14,     0,  0,    0,        0,    2,    0,  buffs[2]},

  {d_billctext_proc,    160,   96,    0,   12,     0,  0,    0,        0,    0,    0,  "Angle"},
  {d_billedit_proc,     120,  112,   80,   14,     0,  0,    0,        0,    3,    0,  buffs[3]},

  {d_ex_billbutton_proc, 90,  136,  140,   16,     0,  0,  'a',        0,    0,    2,  "Edit &AI Scripts", SetRet},

  {d_ex_billbutton_proc, 40,  160,   80,   16,     0,  0,  'o',        0,    0,    1,  "&OK", SetRet},
  {d_ex_billbutton_proc,200,  160,   80,   16,     0,  0,   27,        0,    0,    0,  "Cancel", SetRet},

  {d_check_exit,          0,    0,    0,    0,     0,  0,    0,        0,    0,    0,  NULL},
  {NULL,                  0,    0,    0,    0,     0,  0,    0,        0,    0,    0,  NULL}
};

#define airlist 3

DIALOG editaiscript[] = {
  /* (dialog proc)       (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
  {d_billwin_proc,        0,    0,  320,  176,     0,  0,    0,        0,    0,    0,  title},

  {d_ex_billbutton_proc,306,    4,   10,   10,     0,  0,    0,        0,    0,    0,  "x", SetRet, NULL},

  {d_billddlist_proc,    80,   24,  160,   14,     0,  0,    0,        0,    0,    0,  waypointlist_getter, NULL},

  {d_billddlist_proc,    60,   48,  200,   14,     0,  0,    0,        0,    0,    0,  actionlist_getter, NULL},

  {d_billctext_proc,    160,   72,    0,   12,     0,  0,    0,        0,    0,    0,  "Target"},
  {d_billedit_proc,     110,   88,  100,   14,     0,  0,    0,        0,    2,    0,  buffs[0]},

  {d_billctext_proc,     80,  112,    0,   12,     0,  0,    0,        0,    0,    0,  "MapX"},
  {d_billctext_proc,    240,  112,    0,   12,     0,  0,    0,        0,    0,    0,  "MapY"},
  {d_billedit_proc,      40,  128,   80,   14,     0,  0,    0,        0,    3,    0,  buffs[1]},
  {d_billedit_proc,     200,  128,   80,   14,     0,  0,    0,        0,    3,    0,  buffs[2]},

  {d_ex_billbutton_proc, 60,  152,   60,   16,     0,  0,  'o',        0,    0,    1,  "&OK", SetRet},
  {d_ex_billbutton_proc,200,  152,   60,   16,     0,  0,   27,        0,    0,    0,  "Cancel", SetRet},

  {d_check_ai,            0,    0,    0,    0,     0,  0,    0,        0,    0,    0,  NULL},
  {d_check_exit,          0,    0,    0,    0,     0,  0,    0,        0,    0,    0,  NULL},
  {NULL,                  0,    0,    0,    0,     0,  0,    0,        0,    0,    0,  NULL}
};

#define ailist 2
#define actionlist 3

DIALOG editplayer[] = {
  /* (dialog proc)       (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
  {d_billwin_proc,        0,    0,  320,  192,     0,  0,    0,        0,    0,    0,  "Edit Player"},

  {d_ex_billbutton_proc,306,    4,   10,   10,     0,  0,    0,        0,    0,    0,  "x", SetRet, NULL},
  {d_billctext_proc,    160,   24,    0,   12,     0,  0,    0,        0,    0,    0,  "Select Player Type", NULL},
  {d_billddlist_proc,    80,   32,  160,   14,     0,  0,    0,        0,    0,    0,  playerlist_getter},

  {d_billctext_proc,     80,   56,    0,   12,     0,  0,    0,        0,    0,    0,  "Bullets"},
  {d_billctext_proc,    160,   56,    0,   12,     0,  0,    0,        0,    0,    0,  "Bombs"},
  {d_billctext_proc,    240,   56,    0,   12,     0,  0,    0,        0,    0,    0,  "Missiles"},
  {d_billedit_proc,      40,   72,   80,   14,     0,  0,    0,        0,    5,    0,  buffs[0]},
  {d_billedit_proc,     120,   72,   80,   14,     0,  0,    0,        0,    2,    0,  buffs[1]},
  {d_billedit_proc,     200,   72,   80,   14,     0,  0,    0,        0,    2,    0,  buffs[2]},

  {d_billctext_proc,    160,   96,    0,   12,     0,  0,    0,        0,    0,    0,  "Angle"},
  {d_billedit_proc,     120,  112,   80,   14,     0,  0,    0,        0,    3,    0,  buffs[3]},

  {d_ex_billbutton_proc, 40,  160,   80,   16,     0,  0,  'o',        0,    0,    1,  "&OK", SetRet},
  {d_ex_billbutton_proc,200,  160,   80,   16,     0,  0,   27,        0,    0,    0,  "Cancel", SetRet},

  {d_check_exit,          0,    0,    0,    0,     0,  0,    0,        0,    0,    0,  NULL},
  {NULL,                  0,    0,    0,    0,     0,  0,    0,        0,    0,    0,  NULL}
};

#define playerlist 3

DIALOG getnumb[] = {
  /* (dialog proc)       (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
  {d_billwin_proc,        0,    0,  320,  100,     0,  0,    0,        0,    0,    0,  "Select Number"},

  {d_ex_billbutton_proc,306,    4,   10,   10,     0,  0,    0,        0,    0,    0,  "x", SetRet, NULL},

  {d_billctext_proc,    160,   24,    0,   12,     0,  0,    0,        0,    0,    0,  buffs[0]},
  {d_billctext_proc,    160,   36,    0,   12,     0,  0,    0,        0,    0,    0,  buffs[1]},
  {d_billedit_proc,     120,   52,   80,   14,     0,  0,    0,        0,    5,    0,  buffs[2]},

  {d_ex_billbutton_proc, 60,   76,   60,   16,     0,  0,  'o',        0,    0,    1,  "&OK", SetRet},
  {d_ex_billbutton_proc,200,   76,   60,   16,     0,  0,   27,        0,    0,    0,  "Cancel", SetRet},

  {d_check_exit,          0,    0,    0,    0,     0,  0,    0,        0,    0,    0,  NULL},
  {NULL,                  0,    0,    0,    0,     0,  0,    0,        0,    0,    0,  NULL}
};
